#Imports
import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six


#Connect to database
conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

maxID = 0
prevID = 0
cons = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
cons2 = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany2 = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

count2 = 0

#Get max measurement ID in database with ActivePlus
cur.execute("SELECT MAX(`ID`) FROM `consumption` WHERE `Method`='ActivePlus'")

for row in cur.fetchall():
    print(maxID)
    maxID = row[0]
    print(maxID)
    
IDcount = 0
prevID = 7350049083690884

#The 20 chosen households
IDs = [7350049083690884
,7350049084530592
,7350049084529299
,7350049084531155
,7350049084529251
,7350049084529213
,7350049084531209
,7350049084529565
,7350049084529497
,7350049084529459
,7350049084529404
,7350049084531339
,7350049084531292
,7350049084531537
,7350049084531469
,7350049084531346
,7350049084530974
,7350049084530912
,7350049084530813
,7350049084530745]

#Define x axis for plot
x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]
day = 0
#JANUARY#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-01-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,32):
        if (day !=5 and day !=6 and day !=12 and day !=13 and day !=19 and day !=20 and day !=26 and day != 27):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany
day = 0
#JUNE#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-06-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,29):
        if (day !=1 and day !=2 and day !=8 and day !=9 and day !=15 and day !=16 and day !=22 and day != 23 and day != 29 and day != 30):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons2[hour] = cons2[hour] + row[0]
                    howmany2[hour] = howmany2[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons2
print howmany2

cur.close()
conn.close()

print "Disconnect OK"

plt.plot(x,cons)
plt.plot(x,cons2)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Consumption [kWh]")
plt.xlabel("Time [hour]")
plt.axis([0,23,600,1400])
plt.grid()
plt.savefig('test.png')
plt.show()
