#SolarGenerationAprMayJun2013.py - This script gathers and plots the solar energy generation from April, May and June 2013#

import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

print("Imports OK")

conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

IDcounter = 1
hour = 0
gen = [0] * 24
gen2 = [0] * 24
gen3 = [0] * 24

tempgen = [0] * 24
tempgen2 = [0] * 24
tempgen3 = [0] * 24

x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]

howmany = [0] * 24
howmany2 = [0] * 24
howmany3 = [0] * 24

total1 = 0
total2 = 0
total3 = 0


#APRIL 2013#
IDcounter = 8638

print "IDcounter before APRIL = %s" % IDcounter

for day in range(0,30):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
            howmany[hour] = howmany[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
            tempgen[hour] = tempgen[hour] / 4
            gen[hour] = gen[hour] + tempgen[hour]
        IDcounter = IDcounter + 1

print "IDcounter before MAY = %s" % IDcounter
#MAY 2013#
for day in range(0,31):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
            howmany2[hour] = howmany2[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
            tempgen2[hour] = tempgen2[hour] / 4
            gen2[hour] = gen2[hour] + tempgen2[hour]
        IDcounter = IDcounter + 1

#JUNE 2013#
print "IDcounter beforeJune = %s" % IDcounter
for day in range(0,30):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
            howmany3[hour] = howmany3[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
            tempgen3[hour] = tempgen3[hour] / 4
            gen3[hour] = gen3[hour] + tempgen3[hour]
        IDcounter = IDcounter + 1

print "IDcounter after JUNE = %s" % IDcounter
print gen
print gen2
print gen3

for hour in range(0,24):
    total1 = total1 + gen[hour]
    total2 = total2 + gen2[hour]
    total3 = total3 + gen3[hour]
    
print total1
print total2
print total3

total1 = total1 / 30
total2 = total2 / 31
total3 = total3 / 30

print total1
print total2
print total3

#IF average
#for hour in range(0,24):
#    gen[hour] = gen[hour] / howmany[hour]
#    gen2[hour] = gen2[hour] / howmany2[hour]
#    gen3[hour] = gen3[hour] / howmany3[hour]



cur.close()
conn.close()

print("Disconnect OK")

plt.plot(x,gen)
plt.plot(x,gen2)
plt.plot(x,gen3)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Generation [MWh]")
plt.xlabel("Time [hour]")
plt.axis([0,23,0,250])
plt.grid()
plt.savefig('test.png')
plt.show()
