import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

print("Imports OK")

conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

maxID = 0
prevID = 0
cons = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

cons2 = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany2 = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

cons3 = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany3 = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

count2 = 0

#Get max measurement ID in database with ActivePlus
cur.execute("SELECT MAX(`ID`) FROM `consumption` WHERE `Method`='ActivePlus'")

for row in cur.fetchall():
    print(maxID)
    maxID = row[0]
    print(maxID)
    
IDcount = 1
prevID = 7350049084530592
x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]

'''
October 2013
'''

cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2012-10-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
for row in cur.fetchall():
    ID = row[0]
    print "ID = %d" % ID
temp = 0
counter = 0

for day in range (1,32):
    if (day !=6 and day !=7 and day !=13 and day !=14 and day !=20 and day !=21 and day !=27 and day != 28):
        for hour in range(0,24):
            cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
            for row in cur.fetchall():
                cons[hour] = cons[hour] + row[0]
                howmany[hour] = howmany[hour] + 1 
                #print howmany       
            ID = ID + 1
        print "day = %d" % day
    else:
        ID = ID + 24 # Skip weekend
        print "Skip weekend"
print cons
print howmany
cur.execute("SELECT `Date` FROM `consumption` WHERE `ID` = %s", ID)
for row in cur.fetchall():
    verify = row[0]
    print verify 
cur.execute("SELECT `Time` FROM `consumption` WHERE `ID` = %s", ID)
for row in cur.fetchall():
    verify = row[0]
    print verify 

for hour in range(0,24):
    cons[hour] = cons[hour] / howmany[hour]

'''
November 2013
'''

cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2012-11-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
for row in cur.fetchall():
    ID = row[0]
    print "ID = %d" % ID
temp = 0
counter = 0

for day in range (1,31):
    if (day !=3 and day !=4 and day !=10 and day !=11 and day !=17 and day !=18 and day !=24 and day != 25):
        for hour in range(0,24):
            cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
            for row in cur.fetchall():
                cons2[hour] = cons2[hour] + row[0]
                howmany2[hour] = howmany2[hour] + 1 
                #print howmany       
            ID = ID + 1
        print "day = %d" % day
    else:
        ID = ID + 24 #Skip weekend
        print "Skip weekend"
print cons2
print howmany2
cur.execute("SELECT `Date` FROM `consumption` WHERE `ID` = %s", ID)
for row in cur.fetchall():
    verify = row[0]
    print verify 
cur.execute("SELECT `Time` FROM `consumption` WHERE `ID` = %s", ID)
for row in cur.fetchall():
    verify = row[0]
    print verify 

for hour in range(0,24):
    cons2[hour] = cons2[hour] / howmany2[hour]

'''
December 2013
'''

cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2012-12-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
for row in cur.fetchall():
    ID = row[0]
    print "ID = %d" % ID
temp = 0
counter = 0

for day in range (1,29):
    if (day !=1 and day !=2 and day !=8 and day !=9 and day !=15 and day !=16 and day !=22 and day != 23):
        for hour in range(0,24):
            cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
            for row in cur.fetchall():
                cons3[hour] = cons3[hour] + row[0]
                howmany3[hour] = howmany3[hour] + 1 
                #print howmany       
            ID = ID + 1
        print "day = %d" % day
    else:
        ID = ID + 24
        print "Skip weekend"
print cons3
print howmany3
cur.execute("SELECT `Date` FROM `consumption` WHERE `ID` = %s", ID)
for row in cur.fetchall():
    verify = row[0]
    print verify 
cur.execute("SELECT `Time` FROM `consumption` WHERE `ID` = %s", ID)
for row in cur.fetchall():
    verify = row[0]
    print verify 

for hour in range(0,24):
    cons3[hour] = cons3[hour] / howmany3[hour]

plt.plot(x,cons)
plt.plot(x,cons2)
plt.plot(x,cons3)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Consumption [kWh]")
plt.xlabel("Time [hour]")
plt.grid()
plt.savefig('test.png')
plt.show()

cur.close()
conn.close()