#Imports
import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six


#Connect to database
conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

maxID = 0
prevID = 0
cons = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

count2 = 0

#Get max measurement ID in database with ActivePlus
cur.execute("SELECT MAX(`ID`) FROM `consumption` WHERE `Method`='ActivePlus'")

for row in cur.fetchall():
    print(maxID)
    maxID = row[0]
    print(maxID)
    
IDcount = 0
prevID = 7350049083690884

#The 20 chosen households
IDs = [7350049083690884
,7350049084530592
,7350049084529299
,7350049084531155
,7350049084529251
,7350049084529213
,7350049084531209
,7350049084529565
,7350049084529497
,7350049084529459
,7350049084529404
,7350049084531339
,7350049084531292
,7350049084531537
,7350049084531469
,7350049084531346
,7350049084530974
,7350049084530912
,7350049084530813
,7350049084530745]

#Define x axis for plot
x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]

total = 0

#OCTOBER#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2012-10-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,32):
        if (day !=6 and day !=7 and day !=13 and day !=14 and day !=20 and day !=21 and day !=27 and day != 28): #Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

for hour in range (0,24):
    total = total + cons[hour]
    
print "total = %.3f" % total

#NOVEMBER#
for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2012-11-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,31):
        if (day !=3 and day !=4 and day !=10 and day !=11 and day !=17 and day !=18 and day !=24 and day != 25): #Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

#DECEMBER#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2012-12-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,32):
        if (day !=1 and day !=2 and day !=8 and day !=9 and day !=15 and day !=16 and day !=22 and day != 23 and day!=29 and day!=30 and day!=31):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

#JANUARY#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-01-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,32):
        if (day !=5 and day !=6 and day !=12 and day !=13 and day !=19 and day !=20 and day !=26 and day != 27):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

#FEBRUARY#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-02-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID

    for day in range (1,29):
        if (day !=2 and day !=3 and day !=9 and day !=10 and day !=16 and day !=17 and day !=23 and day != 24):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

#MARCH#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-03-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID

    for day in range (1,32):
        if (day !=2 and day !=3 and day !=9 and day !=10 and day !=16 and day !=17 and day !=23 and day != 24 and day != 30 and day != 31):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

#APRIL#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-04-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,31):
        if (day !=6 and day !=7 and day !=13 and day !=14 and day !=20 and day !=21 and day !=27 and day != 28):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

#MAY#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-05-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,32):
        if (day !=4 and day !=5 and day !=11 and day !=12 and day !=18 and day !=19 and day !=25 and day != 26):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany

#JUNE#

for IDcount in range(0,20):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-06-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,29):
        if (day !=1 and day !=2 and day !=8 and day !=9 and day !=15 and day !=16 and day !=22 and day != 23 and day != 29 and day != 30):#Week days only
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip weekend"
print cons
print howmany


#IF AVERAGE
#for hour in range(0,24):
#    cons[hour] = cons[hour] / howmany[hour]

cur.close()
conn.close()

for hour in range (0,24):
    total = total + cons[hour]
    
print "total = %.3f" % total

print "Disconnect OK"

plt.plot(x,cons)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Consumption [kWh]")
plt.xlabel("Time [hour]")
#plt.axis([0,23,2600,4400])
plt.grid()
plt.savefig('test.png')
plt.show()
