#SolarGenerationOctNovDec.py - This script gathers and plots the solar energy generation from October, November and December 2013#

import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

conn = MySQLdb.connect(host="localhost", # host
                     user="root", # username
                      passwd="root", # password
                      db="demosteinkjer") # name of database

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

IDcounter = 1
hour = 0
gen = [0] * 24
gen2 = [0] * 24
gen3 = [0] * 24

tempgen = [0] * 24
tempgen2 = [0] * 24
tempgen3 = [0] * 24

x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]

howmany = [0] * 24
howmany2 = [0] * 24
howmany3 = [0] * 24

total1 = 0
total2 = 0
total3 = 0

#October 2013#

cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
for row in cur.fetchall():
    gen[hour] = float(row[0])
IDcounter = IDcounter + 1
howmany[hour] = howmany[hour] + 1

for hour in range(1,24):
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = float(row[0])
        howmany[hour] = howmany[hour] + 1
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
        gen[hour] = gen[hour] / 4
    IDcounter = IDcounter + 1

print "IDcounter before rest of October = %s" % IDcounter

for day in range(0,30):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
            howmany[hour] = howmany[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
            tempgen[hour] = tempgen[hour] / 4
            gen[hour] = gen[hour] + tempgen[hour]
        IDcounter = IDcounter + 1

print "IDcounter before Nov = %s" % IDcounter

#November 2013#
for day in range(0,30):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
            howmany2[hour] = howmany2[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
            tempgen2[hour] = tempgen2[hour] / 4
            gen2[hour] = gen2[hour] + tempgen2[hour]
        IDcounter = IDcounter + 1

#December 2013#
print "IDcounter before Dec = %s" % IDcounter
for day in range(0,31):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
            howmany3[hour] = howmany3[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationoctnovdec2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen3[hour] = tempgen3[hour] + float(row[0])
            tempgen3[hour] = tempgen3[hour] / 4
            gen3[hour] = gen3[hour] + tempgen3[hour]
        IDcounter = IDcounter + 1

print gen
print gen2
print gen3

for hour in range(0,24):
    total1 = total1 + gen[hour]
    total2 = total2 + gen2[hour]
    total3 = total3 + gen3[hour]
    
print total1
print total2
print total3

total1 = total1 / 31
total2 = total2 / 30
total3 = total3 / 31

print total1
print total2
print total3

cur.close()
conn.close()

print("Disconnect OK")

plt.plot(x,gen)
plt.plot(x,gen2)
plt.plot(x,gen3)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Generation [MWh]")
plt.xlabel("Time [hour]")
plt.axis([0,23,0,140])
plt.grid()
plt.savefig('test.png')
plt.show()
