'''This script calculates the consumption update each hour in the entire database'''

import MySQLdb
import sys

conn = MySQLdb.connect(host="localhost", # host
                     user="root", # username
                      passwd="root", # password
                      db="demosteinkjer") # name of database

conn.autocommit(True)
cur = conn.cursor()

idcount = 2
data1 = 0
data2 = 0
maxID = 0
hourlycons = 0

cur.execute("SELECT MAX(`ID`) FROM `consumption` WHERE `Method`='ActivePlus'")
for row in cur.fetchall():
    maxID = row[0]

while(idcount <= maxID):
    idcount = idcount - 1
    cur.execute("SELECT `Consumption` FROM `consumption` WHERE `ID`= %s AND `Method`='ActivePlus'", idcount)
    for row in cur.fetchall():
        data1 = row[0]
    
    idcount = idcount +1
    print "IDCOUNT: %d" % idcount
    cur.execute("SELECT `Consumption` FROM `consumption` WHERE `ID`= %s AND `Method`='ActivePlus'", idcount)
    for row in cur.fetchall():
        data2 = row[0]
    
    hourlycons = data2 - data1
    cur.execute("UPDATE `consumption` SET `HourlyConsumption`= %s WHERE `ID`= %s AND `Method`='ActivePlus'", [hourlycons, idcount])
    print "Hourly cons: %.3f" % hourlycons
    idcount = idcount + 1

cur.close()
conn.close()