'''comparepredictedandcorrectedJanuary.py - This script compares predicted and actual energy generation in January'''

import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

print("Imports OK")

conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

IDcounter = 5665#1#11521#8641#5665#2977#1#5857 #Start January 2013
hour = 0
gen = [0] * 24
gen2 = [0] * 24
gen3 = [0] * 24

tempgen = [0] * 24
tempgen2 = [0] * 24

x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]

howmany = [0] * 24
howmany2 = [0] * 24

total1 = 0
total2 = 0

#JANUAR 2013#

cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
for row in cur.fetchall():
    gen[hour] = float(row[0])
IDcounter = IDcounter + 1
howmany[hour] = howmany[hour] + 1

for hour in range(1,24):
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = float(row[0])
        howmany[hour] = howmany[hour] + 1
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
        gen[hour] = gen[hour] / 4
    IDcounter = IDcounter + 1

print "IDcounter before rest of January = %s" % IDcounter

for day in range(0,30):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
            howmany[hour] = howmany[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen[hour] = tempgen[hour] + float(row[0])
            tempgen[hour] = tempgen[hour] / 4
            gen[hour] = gen[hour] + tempgen[hour]
        IDcounter = IDcounter + 1

#JANUAR Predicted 2013#
IDcounter = 5665#1#11521#8641#5665#2977#1#5857
hour = 0

cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
for row in cur.fetchall():
    gen2[hour] = float(row[0])
IDcounter = IDcounter + 1
howmany2[hour] = howmany2[hour] + 1

for hour in range(1,24):
    cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = float(row[0])
        howmany2[hour] = howmany2[hour] + 1
    IDcounter = IDcounter + 1
    cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = gen2[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = gen2[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = gen2[hour] + float(row[0])
        gen2[hour] = gen2[hour] / 4
    IDcounter = IDcounter + 1

print "IDcounter before rest of January = %s" % IDcounter

for day in range(0,30):
    for hour in range(0,24):
        cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
            howmany2[hour] = howmany2[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `Day-AheadforecastMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            tempgen2[hour] = tempgen2[hour] + float(row[0])
            tempgen2[hour] = tempgen2[hour] / 4
            gen2[hour] = gen2[hour] + tempgen2[hour]
        IDcounter = IDcounter + 1

print gen
print howmany
print gen2
print howmany2
#print gen3

for hour in range(0,24):
    total1 = total1 + gen[hour]
    total2 = total2 + gen2[hour]

print "total1 = %.2f MW" % total1
print "total2 = %.2f MW" % total2

cur.close()
conn.close()

print("Disconnect OK")

plt.plot(x,gen)
plt.plot(x,gen2)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Generation [MWh]")
plt.xlabel("Time [hour]")
plt.axis([0,23,0,120])
plt.grid()
plt.savefig('test.png')
plt.show()
